#!/usr/bin/perl

# pmadr2tb.pl

# Copyright (c) 2004, 2005 Robert Dahlem (pmm2tb@dahlem.name)

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


$PMMAIL_SEP = "";

if($#ARGV ne 1) {
	printf STDERR "usage: %s PMMail_ADDR_DB CSV-File\n", $0;
	exit 1;
}

open(ADDR_DB, "$ARGV[0]") or die "$ARGV[0]: $!";
open(CSV, ">", "$ARGV[1]") or die "$ARGV[1]: $!";


while(<ADDR_DB>) {
	chomp;
	$n++;
	@f=split($PMMAIL_SEP, $_);
	for($i=1; $i <= $#f; $i++) {
		$f[$i] =~ s///g;
	}
	printf CSV ",,%s,%s,%s,,%s,%s,%s,,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,,%s,,,,,,,,,,%s,\n",
		$f[ 2], 			# First+Last Name		-> Display Name
		$f[ 1], 			# Alias				-> Nickname
		$f[ 0], 			# Email				-> Email
		$f[20] eq ""			# Work Phone Extension
			? $f[19]		# Work Phone			-> Work Phone
			: "$f[19]-$f[20]",
		$f[12] eq ""			# Home Phone Extension
			? $f[11]		# Home Phone			-> Home Phone
			: "$f[11]-$f[12]",
		$f[21],				# Business Fax			-> Fax
		$f[13],				# Home Fax			-> Mobile Phone
		$f[ 6],				# Home Street			-> Home Address 1
		$f[ 7],				# Home Building			-> Home Address 2
		$f[ 8],				# Home City			-> Home City
		$f[ 9],				# Home State			-> Home State
		$f[10],				# Home Postal Code		-> Home ZIP
		$f[24],				# Home Country			-> Home Country
		$f[14],				# Business Street		-> Work Address 1
		$f[15],				# Business Building		-> Work Address 2
		$f[16],				# Business City			-> Work City
		$f[17],				# Business State		-> Work State
		$f[18],				# Business Postal Code		-> Work ZIP
		$f[25],				# Business Country		-> Work Country
		$f[ 5],				# Title				-> Work Title
		$f[ 4],				# Company			-> Work Organization
		$f[22];				# Notes				-> Notes
}

close(ADDR_DB);
close(CSV);

printf "Converted %d address%s.\n", $n, $n == 1 ? "" : "es";
